(* Examples of creating monad stacks *)

module O = Monad.Option
module L = Monad.List
module T = Monad.LTree
module R = Monad.Reader(struct type env = int end)
module Y = Monad.Reader(struct type env = char end)
module S = Monad.State(struct type store = int end)
module F = Monad.Ref(struct type value = int end)
module W = Monad.Writer1
module E = Monad.Failure


module OO = struct
  include O.T(O)
  include Monad.Derive.Option_dbl(O)(O.T(O))
end
module OL = struct
  include O.P(L)
  include Monad.Derive.List(L)(O.P(L))
end
module OT = struct
  include O.P(T)
  include Monad.Derive.Tree(T)(O.P(T))
end
module OR = struct
  include O.T(R)
  include Monad.Derive.Reader(R)(O.T(R))
end
module OS = struct
  include O.T(S)
  include Monad.Derive.State(S)(O.T(S))
end
module OF = struct
  include O.T(F)
  include Monad.Derive.Ref(F)(O.T(F))
end
module OW = struct
  include O.TW(W)
  include Monad.Derive.Writer(W)(O.TW(W))
end
module OE = struct
  include O.TE(E)
  include Monad.Derive.Error(E)(O.TE(E))
end
module LO = struct
  include L.T(O)
  include Monad.Derive.Option(O)(L.T(O))
end
module LL = struct
  include L.T(L)
  include Monad.Derive.List_dbl(L)(L.T(L))
end
module LT = struct
  include L.T(T)
  include Monad.Derive.Tree(T)(L.T(T))
end
module LR = struct
  include L.T(R)
  include Monad.Derive.Reader(R)(L.T(R))
end
module LY = struct
  include L.T(Y)
  include Monad.Derive.Reader(Y)(L.T(Y))
end
module LS = struct
  include L.T(S)
  include Monad.Derive.State(S)(L.T(S))
end
module LF = struct
  include L.T(F)
  include Monad.Derive.Ref(F)(L.T(F))
end
module LW = struct
  include L.TW(W)
  include Monad.Derive.Writer(W)(L.TW(W))
end
module LE = struct
  include L.TE(E)
  include Monad.Derive.Error(E)(L.TE(E))
end
module TO = struct
  include T.Z(O)
  include Monad.Derive.Option(O)(T.Z(O))
end
module TL = struct
  include T.Z(L)
  include Monad.Derive.List(L)(T.Z(L))
end
module TT = struct
  include T.T(T)
  include Monad.Derive.Tree_dbl(T)(T.T(T))
end
module TR = struct
  include T.T(R)
  include Monad.Derive.Reader(R)(T.T(R))
end
module TS = struct
  include T.T(S)
  include Monad.Derive.State(S)(T.T(S))
end
module TF = struct
  include T.T(F)
  include Monad.Derive.Ref(F)(T.T(F))
end
module TW = struct
  include T.TW(W)
  include Monad.Derive.Writer(W)(T.TW(W))
end
module TE = struct
  include T.TE(E)
  include Monad.Derive.Error(E)(T.TE(E))
end
module RO = struct
  include R.Z(O)
  include Monad.Derive.Option(O)(R.Z(O))
end
module RL = struct
  include R.M(L)
  include Monad.Derive.List(L)(R.M(L))
end
module YL = struct
  include Y.M(L)
  include Monad.Derive.List(L)(Y.M(L))
end
module RT = struct
  include R.P(T)
  include Monad.Derive.Tree(T)(R.P(T))
end
module RY = struct
  include R.T(Y)
  include Monad.Derive.Reader_dbl(Y)(R.T(Y))
end
module YR = struct
  include Y.T(R)
  include Monad.Derive.Reader_dbl(R)(Y.T(R))
end
module RS = struct
  include R.T(S)
  include Monad.Derive.State(S)(R.T(S))
end
module RF = struct
  include R.T(F)
  include Monad.Derive.Ref(F)(R.T(F))
end
module RW = struct
  include R.TW(W)
  include Monad.Derive.Writer(W)(R.TW(W))
end
module RE = struct
  include R.TE(E)
  include Monad.Derive.Error(E)(R.TE(E))
end
module SO = struct
  include S.Z(O)
  include Monad.Derive.Option(O)(S.Z(O))
end
module SL = struct
  include S.M(L)
  include Monad.Derive.List(L)(S.M(L))
end
module ST = struct
  include S.P(T)
  include Monad.Derive.Tree(T)(S.P(T))
end
module SR = struct
  include S.T(R)
  include Monad.Derive.Reader(R)(S.T(R))
end
module SS = struct
  include S.T(S)
  include Monad.Derive.State_dbl(S)(S.T(S))
end
module SF = struct
  include S.T(F)
  include Monad.Derive.Ref(F)(S.T(F))
end
module SW = struct
  include S.TW(W)
  include Monad.Derive.Writer(W)(S.TW(W))
end
module SE = struct
  include S.TE(E)
  include Monad.Derive.Error(E)(S.TE(E))
end
module FO = struct
  include F.Z(O)
  include Monad.Derive.Option(O)(F.Z(O))
end
module FL = struct
  include F.M(L)
  include Monad.Derive.List(L)(F.M(L))
end
module FT = struct
  include F.P(T)
  include Monad.Derive.Tree(T)(F.P(T))
end
module FR = struct
  include F.T(R)
  include Monad.Derive.Reader(R)(F.T(R))
end
module FS = struct
  include F.T(S)
  include Monad.Derive.State(S)(F.T(S))
end
module FF = struct
  include F.T(F)
  include Monad.Derive.Ref_dbl(F)(F.T(F))
end
module FW = struct
  include F.TW(W)
  include Monad.Derive.Writer(W)(F.TW(W))
end
module FE = struct
  include F.TE(E)
  include Monad.Derive.Error(E)(F.TE(E))
end
module WO = struct
  include W.Z(O)
  include Monad.Derive.Option_toW(O)(W.Z(O))
end
module WL = struct
  include W.M(L)
  include Monad.Derive.List_toW(L)(W.M(L))
end
module WT = struct
  include W.P(T)
  include Monad.Derive.Tree_toW(T)(W.P(T))
end
module WR = struct
  include W.T(R)
  include Monad.Derive.Reader_toW(R)(W.T(R))
end
module WS = struct
  include W.T(S)
  include Monad.Derive.State_toW(S)(W.T(S))
end
module WF = struct
  include W.T(F)
  include Monad.Derive.Ref_toW(F)(W.T(F))
end
(*
module WW = struct
  (* FIXME *)
  include W.T(W)
  include Monad.Derive.WriterW(W)(W.T(W))
end
*)
module WE = struct
  include W.TE(E)
  include Monad.Derive.Error_toW(E)(W.TE(E))
end
module EO = struct
  include E.Z(O)
  include Monad.Derive.Option_toE(O)(E.Z(O))
end
module EL = struct
  include E.M(L)
  include Monad.Derive.List_toE(L)(E.M(L))
end
module ET = struct
  include E.P(T)
  include Monad.Derive.Tree_toE(T)(E.P(T))
end
module ER = struct
  include E.T(R)
  include Monad.Derive.Reader_toE(R)(E.T(R))
end
module ES = struct
  include E.T(S)
  include Monad.Derive.State_toE(S)(E.T(S))
end
module EF = struct
  include E.T(F)
  include Monad.Derive.Ref_toE(F)(E.T(F))
end
module EW = struct
  include E.TW(W)
  include Monad.Derive.Writer_toE(W)(E.TW(W))
end
(*
module EE = struct
  include E.T(E)
  (* FIXME *)
  include Monad.Derive.Error_toE(E)(E.T(E))
end
*)

(* WORKING *)

module LRY = struct
  include L.T(RY)
  include Monad.Derive.Reader2(RY)(L.T(RY))
end
module LYR = struct
  include L.T(YR)
  include Monad.Derive.Reader2(YR)(L.T(YR))
end
module RLY = struct
  include R.M(LY)
  include Monad.Derive.List(LY)(R.M(LY))
  include Monad.Derive.Reader_dbl(LY)(R.M(LY))
end
module RYL = struct
  include R.M(YL)
  include Monad.Derive.List(YL)(R.M(YL))
  include Monad.Derive.Reader_dbl(YL)(R.M(YL))
end
module YLR = struct
  include Y.M(LR)
  include Monad.Derive.List(LR)(Y.M(LR))
  include Monad.Derive.Reader_dbl(LR)(Y.M(LR))
end
module YRL = struct
  include Y.M(RL)
  include Monad.Derive.List(RL)(Y.M(RL))
  include Monad.Derive.Reader_dbl(RL)(Y.M(RL))
end


(* Three-way with WE *)

module OWE = struct
  include O.TX(WE)
  include Monad.Derive.ErrorW(WE)(O.TX(WE))
  include Monad.Derive.WriterE(WE)(O.TX(WE))
end
module OEW = struct
  include O.TX(EW)
  include Monad.Derive.ErrorW(EW)(O.TX(EW))
  include Monad.Derive.WriterE(EW)(O.TX(EW))
end
module WEO = struct
  include W.ZE(EO)
  include Monad.Derive.Error_toW(EO)(W.ZE(EO))
  include Monad.Derive.OptionE_toW(EO)(W.ZE(EO))
end
module WOE = struct
  include W.ZE(OE)
  include Monad.Derive.Error_toW(OE)(W.ZE(OE))
  include Monad.Derive.OptionE_toW(OE)(W.ZE(OE))
end
module EWO = struct
  include E.ZW(WO)
  include Monad.Derive.Writer_toE(WO)(E.ZW(WO))
  include Monad.Derive.OptionW_toE(WO)(E.ZW(WO))
end
module EOW = struct
  include E.ZW(OW)
  include Monad.Derive.Writer_toE(OW)(E.ZW(OW))
  include Monad.Derive.OptionW_toE(OW)(E.ZW(OW))
end

module LWE = struct
  include L.TX(WE)
  include Monad.Derive.ErrorW(WE)(L.TX(WE))
  include Monad.Derive.WriterE(WE)(L.TX(WE))
end
module LEW = struct
  include L.TX(EW)
  include Monad.Derive.ErrorW(EW)(L.TX(EW))
  include Monad.Derive.WriterE(EW)(L.TX(EW))
end
module WEL = struct
  include W.ME(EL)
  include Monad.Derive.Error_toW(EL)(W.ME(EL))
  include Monad.Derive.ListE_toW(EL)(W.ME(EL))
end
module WLE = struct
  include W.ME(LE)
  include Monad.Derive.Error_toW(LE)(W.ME(LE))
  include Monad.Derive.ListE_toW(LE)(W.ME(LE))
end
module EWL = struct
  include E.MW(WL)
  include Monad.Derive.Writer_toE(WL)(E.MW(WL))
  include Monad.Derive.ListW_toE(WL)(E.MW(WL))
end
module ELW = struct
  include E.MW(LW)
  include Monad.Derive.Writer_toE(LW)(E.MW(LW))
  include Monad.Derive.ListW_toE(LW)(E.MW(LW))
end

module TWE = struct
  include T.TX(WE)
  include Monad.Derive.ErrorW(WE)(T.TX(WE))
  include Monad.Derive.WriterE(WE)(T.TX(WE))
end
module TEW = struct
  include T.TX(EW)
  include Monad.Derive.ErrorW(EW)(T.TX(EW))
  include Monad.Derive.WriterE(EW)(T.TX(EW))
end
module WET = struct
  include W.PE(ET)
  include Monad.Derive.Error_toW(ET)(W.PE(ET))
  include Monad.Derive.TreeE_toW(ET)(W.PE(ET))
end
module WTE = struct
  include W.PE(TE)
  include Monad.Derive.Error_toW(TE)(W.PE(TE))
  include Monad.Derive.TreeE_toW(TE)(W.PE(TE))
end
module EWT = struct
  include E.PW(WT)
  include Monad.Derive.Writer_toE(WT)(E.PW(WT))
  include Monad.Derive.TreeW_toE(WT)(E.PW(WT))
end
module ETW = struct
  include E.PW(TW)
  include Monad.Derive.Writer_toE(TW)(E.PW(TW))
  include Monad.Derive.TreeW_toE(TW)(E.PW(TW))
end

module RWE = struct
  include R.TX(WE)
  include Monad.Derive.ErrorW(WE)(R.TX(WE))
  include Monad.Derive.WriterE(WE)(R.TX(WE))
end
module REW = struct
  include R.TX(EW)
  include Monad.Derive.ErrorW(EW)(R.TX(EW))
  include Monad.Derive.WriterE(EW)(R.TX(EW))
end
module WER = struct
  include W.TE(ER)
  include Monad.Derive.Error_toW(ER)(W.TE(ER))
  include Monad.Derive.ReaderE_toW(ER)(W.TE(ER))
end
module WRE = struct
  include W.TE(RE)
  include Monad.Derive.Error_toW(RE)(W.TE(RE))
  include Monad.Derive.ReaderE_toW(RE)(W.TE(RE))
end
module EWR = struct
  include E.TW(WR)
  include Monad.Derive.Writer_toE(WR)(E.TW(WR))
  include Monad.Derive.ReaderW_toE(WR)(E.TW(WR))
end
module ERW = struct
  include E.TW(RW)
  include Monad.Derive.Writer_toE(RW)(E.TW(RW))
  include Monad.Derive.ReaderW_toE(RW)(E.TW(RW))
end

module SWE = struct
  include S.TX(WE)
  include Monad.Derive.ErrorW(WE)(S.TX(WE))
  include Monad.Derive.WriterE(WE)(S.TX(WE))
end
module SEW = struct
  include S.TX(EW)
  include Monad.Derive.ErrorW(EW)(S.TX(EW))
  include Monad.Derive.WriterE(EW)(S.TX(EW))
end
module WES = struct
  include W.TE(ES)
  include Monad.Derive.Error_toW(ES)(W.TE(ES))
  include Monad.Derive.StateE_toW(ES)(W.TE(ES))
end
module WSE = struct
  include W.TE(SE)
  include Monad.Derive.Error_toW(SE)(W.TE(SE))
  include Monad.Derive.StateE_toW(SE)(W.TE(SE))
end
module EWS = struct
  include E.TW(WS)
  include Monad.Derive.Writer_toE(WS)(E.TW(WS))
  include Monad.Derive.StateW_toE(WS)(E.TW(WS))
end
module ESW = struct
  include E.TW(SW)
  include Monad.Derive.Writer_toE(SW)(E.TW(SW))
  include Monad.Derive.StateW_toE(SW)(E.TW(SW))
end

module FWE = struct
  include F.TX(WE)
  include Monad.Derive.ErrorW(WE)(F.TX(WE))
  include Monad.Derive.WriterE(WE)(F.TX(WE))
end
module FEW = struct
  include F.TX(EW)
  include Monad.Derive.ErrorW(EW)(F.TX(EW))
  include Monad.Derive.WriterE(EW)(F.TX(EW))
end
module WEF = struct
  include W.TE(EF)
  include Monad.Derive.Error_toW(EF)(W.TE(EF))
  include Monad.Derive.RefE_toW(EF)(W.TE(EF))
end
module WFE = struct
  include W.TE(FE)
  include Monad.Derive.Error_toW(FE)(W.TE(FE))
  include Monad.Derive.RefE_toW(FE)(W.TE(FE))
end
module EWF = struct
  include E.TW(WF)
  include Monad.Derive.Writer_toE(WF)(E.TW(WF))
  include Monad.Derive.RefW_toE(WF)(E.TW(WF))
end
module EFW = struct
  include E.TW(FW)
  include Monad.Derive.Writer_toE(FW)(E.TW(FW))
  include Monad.Derive.RefW_toE(FW)(E.TW(FW))
end

(* Three-way with WR *)

module OWR = struct
  include O.TW(WR)
  include Monad.Derive.ReaderW(WR)(O.TW(WR))
  include Monad.Derive.Writer(WR)(O.TW(WR))
end
module ORW = struct
  include O.TW(RW)
  include Monad.Derive.ReaderW(RW)(O.TW(RW))
  include Monad.Derive.Writer(RW)(O.TW(RW))
end
module WRO = struct
  include W.Z(RO)
  include Monad.Derive.Reader_toW(RO)(W.Z(RO))
  include Monad.Derive.Option_toW(RO)(W.Z(RO))
end
module WOR = struct
  include W.Z(OR)
  include Monad.Derive.Reader_toW(OR)(W.Z(OR))
  include Monad.Derive.Option_toW(OR)(W.Z(OR))
end
module RWO = struct
  include R.ZW(WO)
  include Monad.Derive.Writer(WO)(R.ZW(WO))
  include Monad.Derive.OptionW(WO)(R.ZW(WO))
end
module ROW = struct
  include R.ZW(OW)
  include Monad.Derive.Writer(OW)(R.ZW(OW))
  include Monad.Derive.OptionW(OW)(R.ZW(OW))
end

module LWR = struct
  include L.TW(WR)
  include Monad.Derive.ReaderW(WR)(L.TW(WR))
  include Monad.Derive.Writer(WR)(L.TW(WR))
end
module LRW = struct
  include L.TW(RW)
  include Monad.Derive.ReaderW(RW)(L.TW(RW))
  include Monad.Derive.Writer(RW)(L.TW(RW))
end
module WRL = struct
  include W.M(RL)
  include Monad.Derive.Reader_toW(RL)(W.M(RL))
  include Monad.Derive.List_toW(RL)(W.M(RL))
end
module WLR = struct
  include W.M(LR)
  include Monad.Derive.Reader_toW(LR)(W.M(LR))
  include Monad.Derive.List_toW(LR)(W.M(LR))
end
module RWL = struct
  include R.MW(WL)
  include Monad.Derive.Writer(WL)(R.MW(WL))
  include Monad.Derive.ListW(WL)(R.MW(WL))
end
module RLW = struct
  include R.MW(LW)
  include Monad.Derive.Writer(LW)(R.MW(LW))
  include Monad.Derive.ListW(LW)(R.MW(LW))
end

module TWR = struct
  include T.TW(WR)
  include Monad.Derive.ReaderW(WR)(T.TW(WR))
  include Monad.Derive.Writer(WR)(T.TW(WR))
end
module TRW = struct
  include T.TW(RW)
  include Monad.Derive.ReaderW(RW)(T.TW(RW))
  include Monad.Derive.Writer(RW)(T.TW(RW))
end
module WRT = struct
  include W.P(RT)
  include Monad.Derive.Reader_toW(RT)(W.P(RT))
  include Monad.Derive.Tree_toW(RT)(W.P(RT))
end
module WTR = struct
  include W.P(TR)
  include Monad.Derive.Reader_toW(TR)(W.P(TR))
  include Monad.Derive.Tree_toW(TR)(W.P(TR))
end
module RWT = struct
  include R.PW(WT)
  include Monad.Derive.Writer(WT)(R.PW(WT))
  include Monad.Derive.TreeW(WT)(R.PW(WT))
end
module RTW = struct
  include R.PW(TW)
  include Monad.Derive.Writer(TW)(R.PW(TW))
  include Monad.Derive.TreeW(TW)(R.PW(TW))
end

module SWR = struct
  include S.TW(WR)
  include Monad.Derive.ReaderW(WR)(S.TW(WR))
  include Monad.Derive.Writer(WR)(S.TW(WR))
end
module SRW = struct
  include S.TW(RW)
  include Monad.Derive.ReaderW(RW)(S.TW(RW))
  include Monad.Derive.Writer(RW)(S.TW(RW))
end
module WRS = struct
  include W.T(RS)
  include Monad.Derive.Reader_toW(RS)(W.T(RS))
  include Monad.Derive.State_toW(RS)(W.T(RS))
end
module WSR = struct
  include W.T(SR)
  include Monad.Derive.Reader_toW(SR)(W.T(SR))
  include Monad.Derive.State_toW(SR)(W.T(SR))
end
module RWS = struct
  include R.TW(WS)
  include Monad.Derive.Writer(WS)(R.TW(WS))
  include Monad.Derive.StateW(WS)(R.TW(WS))
end
module RSW = struct
  include R.TW(SW)
  include Monad.Derive.Writer(SW)(R.TW(SW))
  include Monad.Derive.StateW(SW)(R.TW(SW))
end

module FWR = struct
  include F.TW(WR)
  include Monad.Derive.ReaderW(WR)(F.TW(WR))
  include Monad.Derive.Writer(WR)(F.TW(WR))
end
module FRW = struct
  include F.TW(RW)
  include Monad.Derive.ReaderW(RW)(F.TW(RW))
  include Monad.Derive.Writer(RW)(F.TW(RW))
end
module WRF = struct
  include W.T(RF)
  include Monad.Derive.Reader_toW(RF)(W.T(RF))
  include Monad.Derive.Ref_toW(RF)(W.T(RF))
end
module WFR = struct
  include W.T(FR)
  include Monad.Derive.Reader_toW(FR)(W.T(FR))
  include Monad.Derive.Ref_toW(FR)(W.T(FR))
end
module RWF = struct
  include R.TW(WF)
  include Monad.Derive.Writer(WF)(R.TW(WF))
  include Monad.Derive.RefW(WF)(R.TW(WF))
end
module RFW = struct
  include R.TW(FW)
  include Monad.Derive.Writer(FW)(R.TW(FW))
  include Monad.Derive.RefW(FW)(R.TW(FW))
end

module EWR' = struct
  include E.TW(WR)
  include Monad.Derive.Writer_toE(WR)(E.TW(WR))
  include Monad.Derive.ReaderW_toE(WR)(E.TW(WR))
end
module ERW' = struct
  include E.TW(RW)
  include Monad.Derive.Writer_toE(RW)(E.TW(RW))
  include Monad.Derive.ReaderW_toE(RW)(E.TW(RW))
end
module WRE' = struct
  include W.TE(RE)
  include Monad.Derive.Error_toW(RE)(W.TE(RE))
  include Monad.Derive.ReaderE_toW(RE)(W.TE(RE))
end
module WER' = struct
  include W.TE(ER)
  include Monad.Derive.Error_toW(ER)(W.TE(ER))
  include Monad.Derive.ReaderE_toW(ER)(W.TE(ER))
end
module RWE' = struct
  include R.TX(WE)
  include Monad.Derive.ErrorW(WE)(R.TX(WE))
  include Monad.Derive.WriterE(WE)(R.TX(WE))
end
module REW' = struct
  include R.TX(EW)
  include Monad.Derive.ErrorW(EW)(R.TX(EW))
  include Monad.Derive.WriterE(EW)(R.TX(EW))
end


(* Three-way with ER *)

module ORE = struct
  include O.TE(RE)
  include Monad.Derive.Error(RE)(O.TE(RE))
  include Monad.Derive.ReaderE(RE)(O.TE(RE))
end
module OER = struct
  include O.TE(ER)
  include Monad.Derive.Error(ER)(O.TE(ER))
  include Monad.Derive.ReaderE(ER)(O.TE(ER))
end
module REO = struct
  include R.ZE(EO)
  include Monad.Derive.Error(EO)(R.ZE(EO))
  include Monad.Derive.OptionE(EO)(R.ZE(EO))
end
module ROE = struct
  include R.ZE(OE)
  include Monad.Derive.Error(OE)(R.ZE(OE))
  include Monad.Derive.OptionE(OE)(R.ZE(OE))
end
module ERO = struct
  include E.Z(RO)
  include Monad.Derive.Reader_toE(RO)(E.Z(RO))
  include Monad.Derive.Option_toE(RO)(E.Z(RO))
end
module EOR = struct
  include E.Z(OR)
  include Monad.Derive.Reader_toE(OR)(E.Z(OR))
  include Monad.Derive.Option_toE(OR)(E.Z(OR))
end

module LRE = struct
  include L.TE(RE)
  include Monad.Derive.Error(RE)(L.TE(RE))
  include Monad.Derive.ReaderE(RE)(L.TE(RE))
end
module LER = struct
  include L.TE(ER)
  include Monad.Derive.Error(ER)(L.TE(ER))
  include Monad.Derive.ReaderE(ER)(L.TE(ER))
end
module REL = struct
  include R.ME(EL)
  include Monad.Derive.Error(EL)(R.ME(EL))
  include Monad.Derive.ListE(EL)(R.ME(EL))
end
module RLE = struct
  include R.ME(LE)
  include Monad.Derive.Error(LE)(R.ME(LE))
  include Monad.Derive.ListE(LE)(R.ME(LE))
end
module ERL = struct
  include E.M(RL)
  include Monad.Derive.Reader_toE(RL)(E.M(RL))
  include Monad.Derive.List_toE(RL)(E.M(RL))
end
module ELR = struct
  include E.M(LR)
  include Monad.Derive.Reader_toE(LR)(E.M(LR))
  include Monad.Derive.List_toE(LR)(E.M(LR))
end

module TRE = struct
  include T.TE(RE)
  include Monad.Derive.Error(RE)(T.TE(RE))
  include Monad.Derive.ReaderE(RE)(T.TE(RE))
end
module TER = struct
  include T.TE(ER)
  include Monad.Derive.Error(ER)(T.TE(ER))
  include Monad.Derive.ReaderE(ER)(T.TE(ER))
end
module RET = struct
  include R.PE(ET)
  include Monad.Derive.Error(ET)(R.PE(ET))
  include Monad.Derive.TreeE(ET)(R.PE(ET))
end
module RTE = struct
  include R.PE(TE)
  include Monad.Derive.Error(TE)(R.PE(TE))
  include Monad.Derive.TreeE(TE)(R.PE(TE))
end
module ERT = struct
  include E.P(RT)
  include Monad.Derive.Reader_toE(RT)(E.P(RT))
  include Monad.Derive.Tree_toE(RT)(E.P(RT))
end
module ETR = struct
  include E.P(TR)
  include Monad.Derive.Reader_toE(TR)(E.P(TR))
  include Monad.Derive.Tree_toE(TR)(E.P(TR))
end

module SRE = struct
  include S.TE(RE)
  include Monad.Derive.Error(RE)(S.TE(RE))
  include Monad.Derive.ReaderE(RE)(S.TE(RE))
end
module SER = struct
  include S.TE(ER)
  include Monad.Derive.Error(ER)(S.TE(ER))
  include Monad.Derive.ReaderE(ER)(S.TE(ER))
end
module RES = struct
  include R.TE(ES)
  include Monad.Derive.Error(ES)(R.TE(ES))
  include Monad.Derive.StateE(ES)(R.TE(ES))
end
module RSE = struct
  include R.TE(SE)
  include Monad.Derive.Error(SE)(R.TE(SE))
  include Monad.Derive.StateE(SE)(R.TE(SE))
end
module ERS = struct
  include E.T(RS)
  include Monad.Derive.Reader_toE(RS)(E.T(RS))
  include Monad.Derive.State_toE(RS)(E.T(RS))
end
module ESR = struct
  include E.T(SR)
  include Monad.Derive.Reader_toE(SR)(E.T(SR))
  include Monad.Derive.State_toE(SR)(E.T(SR))
end

module FRE = struct
  include F.TE(RE)
  include Monad.Derive.Error(RE)(F.TE(RE))
  include Monad.Derive.ReaderE(RE)(F.TE(RE))
end
module FER = struct
  include F.TE(ER)
  include Monad.Derive.Error(ER)(F.TE(ER))
  include Monad.Derive.ReaderE(ER)(F.TE(ER))
end
module REF = struct
  include R.TE(EF)
  include Monad.Derive.Error(EF)(R.TE(EF))
  include Monad.Derive.RefE(EF)(R.TE(EF))
end
module RFE = struct
  include R.TE(FE)
  include Monad.Derive.Error(FE)(R.TE(FE))
  include Monad.Derive.RefE(FE)(R.TE(FE))
end
module ERF = struct
  include E.T(RF)
  include Monad.Derive.Reader_toE(RF)(E.T(RF))
  include Monad.Derive.Ref_toE(RF)(E.T(RF))
end
module EFR = struct
  include E.T(FR)
  include Monad.Derive.Reader_toE(FR)(E.T(FR))
  include Monad.Derive.Ref_toE(FR)(E.T(FR))
end

module WRE'' = struct
  include W.TE(RE)
  include Monad.Derive.Error_toW(RE)(W.TE(RE))
  include Monad.Derive.ReaderE_toW(RE)(W.TE(RE))
end
module WER'' = struct
  include W.TE(ER)
  include Monad.Derive.Error_toW(ER)(W.TE(ER))
  include Monad.Derive.ReaderE_toW(ER)(W.TE(ER))
end
module REW'' = struct
  include R.TX(EW)
  include Monad.Derive.ErrorW(EW)(R.TX(EW))
  include Monad.Derive.WriterE(EW)(R.TX(EW))
end
module RWE'' = struct
  include R.TX(WE)
  include Monad.Derive.ErrorW(WE)(R.TX(WE))
  include Monad.Derive.WriterE(WE)(R.TX(WE))
end
module ERW'' = struct
  include E.TW(RW)
  include Monad.Derive.Writer_toE(RW)(E.TW(RW))
  include Monad.Derive.ReaderW_toE(RW)(E.TW(RW))
end
module EWR'' = struct
  include E.TW(WR)
  include Monad.Derive.Writer_toE(WR)(E.TW(WR))
  include Monad.Derive.ReaderW_toE(WR)(E.TW(WR))
end


(* Four-way *)

module RWEO = struct
  include R.ZX(WEO)
  include Monad.Derive.WriterE(WEO)(R.ZX(WEO))
  include Monad.Derive.ErrorW(WEO)(R.ZX(WEO))
  include Monad.Derive.OptionX(WEO)(R.ZX(WEO))
end
module REWO = struct
  include R.ZX(EWO)
  include Monad.Derive.ErrorW(EWO)(R.ZX(EWO))
  include Monad.Derive.WriterE(EWO)(R.ZX(EWO))
  include Monad.Derive.OptionX(EWO)(R.ZX(EWO))
end
module RWOE = struct
  include R.ZX(WOE)
  include Monad.Derive.WriterE(WOE)(R.ZX(WOE))
  include Monad.Derive.OptionX(WOE)(R.ZX(WOE))
  include Monad.Derive.ErrorW(WOE)(R.ZX(WOE))
end
module REOW = struct
  include R.ZX(EOW)
  include Monad.Derive.ErrorW(EOW)(R.ZX(EOW))
  include Monad.Derive.OptionX(EOW)(R.ZX(EOW))
  include Monad.Derive.WriterE(EOW)(R.ZX(EOW))
end
module ROWE = struct
  include R.ZX(OWE)
  include Monad.Derive.OptionX(OWE)(R.ZX(OWE))
  include Monad.Derive.WriterE(OWE)(R.ZX(OWE))
  include Monad.Derive.ErrorW(OWE)(R.ZX(OWE))
end
module ROEW = struct
  include R.ZX(OEW)
  include Monad.Derive.OptionX(OEW)(R.ZX(OEW))
  include Monad.Derive.ErrorW(OEW)(R.ZX(OEW))
  include Monad.Derive.WriterE(OEW)(R.ZX(OEW))
end

module OWER = struct
  include O.TX(WER)
  include Monad.Derive.WriterE(WER)(O.TX(WER))
  include Monad.Derive.ErrorW(WER)(O.TX(WER))
  include Monad.Derive.ReaderX(WER)(O.TX(WER))
end
module OEWR = struct
  include O.TX(EWR)
  include Monad.Derive.ErrorW(EWR)(O.TX(EWR))
  include Monad.Derive.WriterE(EWR)(O.TX(EWR))
  include Monad.Derive.ReaderX(EWR)(O.TX(EWR))
end
module OWRE = struct
  include O.TX(WRE)
  include Monad.Derive.WriterE(WRE)(O.TX(WRE))
  include Monad.Derive.ReaderX(WRE)(O.TX(WRE))
  include Monad.Derive.ErrorW(WRE)(O.TX(WRE))
end
module OERW = struct
  include O.TX(ERW)
  include Monad.Derive.ErrorW(ERW)(O.TX(ERW))
  include Monad.Derive.ReaderX(ERW)(O.TX(ERW))
  include Monad.Derive.WriterE(ERW)(O.TX(ERW))
end
module ORWE = struct
  include O.TX(RWE)
  include Monad.Derive.ReaderX(RWE)(O.TX(RWE))
  include Monad.Derive.WriterE(RWE)(O.TX(RWE))
  include Monad.Derive.ErrorW(RWE)(O.TX(RWE))
end
module OREW = struct
  include O.TX(REW)
  include Monad.Derive.ReaderX(REW)(O.TX(REW))
  include Monad.Derive.ErrorW(REW)(O.TX(REW))
  include Monad.Derive.WriterE(REW)(O.TX(REW))
end

module EWRO = struct
  include E.ZW(WRO)
  include Monad.Derive.Writer_toE(WRO)(E.ZW(WRO))
  include Monad.Derive.ReaderW_toE(WRO)(E.ZW(WRO))
  include Monad.Derive.OptionW_toE(WRO)(E.ZW(WRO))
end
module EWOR = struct
  include E.ZW(WOR)
  include Monad.Derive.Writer_toE(WOR)(E.ZW(WOR))
  include Monad.Derive.OptionW_toE(WOR)(E.ZW(WOR))
  include Monad.Derive.ReaderW_toE(WOR)(E.ZW(WOR))
end
module ERWO = struct
  include E.ZW(RWO)
  include Monad.Derive.ReaderW_toE(RWO)(E.ZW(RWO))
  include Monad.Derive.Writer_toE(RWO)(E.ZW(RWO))
  include Monad.Derive.OptionW_toE(RWO)(E.ZW(RWO))
end
module EOWR = struct
  include E.ZW(OWR)
  include Monad.Derive.OptionW_toE(OWR)(E.ZW(OWR))
  include Monad.Derive.Writer_toE(OWR)(E.ZW(OWR))
  include Monad.Derive.ReaderW_toE(OWR)(E.ZW(OWR))
end
module EROW = struct
  include E.ZW(ROW)
  include Monad.Derive.ReaderW_toE(ROW)(E.ZW(ROW))
  include Monad.Derive.OptionW_toE(ROW)(E.ZW(ROW))
  include Monad.Derive.Writer_toE(ROW)(E.ZW(ROW))
end
module EORW = struct
  include E.ZW(ORW)
  include Monad.Derive.OptionW_toE(ORW)(E.ZW(ORW))
  include Monad.Derive.ReaderW_toE(ORW)(E.ZW(ORW))
  include Monad.Derive.Writer_toE(ORW)(E.ZW(ORW))
end

module WERO = struct
  include W.ZE(ERO)
  include Monad.Derive.Error_toW(ERO)(W.ZE(ERO))
  include Monad.Derive.ReaderE_toW(ERO)(W.ZE(ERO))
  include Monad.Derive.OptionE_toW(ERO)(W.ZE(ERO))
end
module WEOR = struct
  include W.ZE(EOR)
  include Monad.Derive.Error_toW(EOR)(W.ZE(EOR))
  include Monad.Derive.OptionE_toW(EOR)(W.ZE(EOR))
  include Monad.Derive.ReaderE_toW(EOR)(W.ZE(EOR))
end
module WREO = struct
  include W.ZE(REO)
  include Monad.Derive.ReaderE_toW(REO)(W.ZE(REO))
  include Monad.Derive.Error_toW(REO)(W.ZE(REO))
  include Monad.Derive.OptionE_toW(REO)(W.ZE(REO))
end
module WOER = struct
  include W.ZE(OER)
  include Monad.Derive.OptionE_toW(OER)(W.ZE(OER))
  include Monad.Derive.Error_toW(OER)(W.ZE(OER))
  include Monad.Derive.ReaderE_toW(OER)(W.ZE(OER))
end
module WROE = struct
  include W.ZE(ROE)
  include Monad.Derive.ReaderE_toW(ROE)(W.ZE(ROE))
  include Monad.Derive.OptionE_toW(ROE)(W.ZE(ROE))
  include Monad.Derive.Error_toW(ROE)(W.ZE(ROE))
end
module WORE = struct
  include W.ZE(ORE)
  include Monad.Derive.OptionE_toW(ORE)(W.ZE(ORE))
  include Monad.Derive.ReaderE_toW(ORE)(W.ZE(ORE))
  include Monad.Derive.Error_toW(ORE)(W.ZE(ORE))
end


module REWL = struct
  include R.MX(EWL)
  include Monad.Derive.ErrorW(EWL)(R.MX(EWL))
  include Monad.Derive.WriterE(EWL)(R.MX(EWL))
  include Monad.Derive.ListX(EWL)(R.MX(EWL))
end
module REWT = struct
  include R.PX(EWT)
  include Monad.Derive.ErrorW(EWT)(R.PX(EWT))
  include Monad.Derive.WriterE(EWT)(R.PX(EWT))
  include Monad.Derive.TreeX(EWT)(R.PX(EWT))
end
module REWS = struct
  include R.TX(EWS)
  include Monad.Derive.ErrorW(EWS)(R.TX(EWS))
  include Monad.Derive.WriterE(EWS)(R.TX(EWS))
  include Monad.Derive.StateX(EWS)(R.TX(EWS))
end
module REWF = struct
  include R.TX(EWF)
  include Monad.Derive.ErrorW(EWF)(R.TX(EWF))
  include Monad.Derive.WriterE(EWF)(R.TX(EWF))
  include Monad.Derive.RefX(EWF)(R.TX(EWF))
end
